#  MR-Vote 0.01, Copyright (C) 2001 Yamamoto Takanori
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#extern &jcode'convert()


# /* global variables */

$JCODE_INT = 'euc';   # internal Japanese character code. do not change this.
$JCODE_EXT = 'sjis';  # code for output. set 'jis', 'sjis', or 'euc'.

$PHASE2HTML = './phase2.html'; # model(form file) for output.
$PHASE3HTML = './phase3.html'; #
$PHASE3CGI  = './phase3.cgi';  #

$TABLEFILE = './result.table'; # csv table file.
$CSVFILE = './result.csv';     # csv file for data storage.

$PASSWORD = 'opensesami'; # administrator password.

$BLANKITEM = '(ʤ)'; &jcode'convert(*BLANKITEM, $JCODE_INT);
$BLANKITEMCOLOR = '"#CC0000"';
$TABLECOLOR1 = '"#F3FFF3"'; #pale
$TABLECOLOR2 = '"#DDEEDD"'; 
$TABLECOLOR3 = '"#CCDDCC"'; #daek


# /* functions */


sub DecodeArguement(){
    my($ps) = shift;
    $$ps =~ tr/+/ /;
    $$ps =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
}


sub GetArgument(){
    my($paaForm) = shift;
    my(@pairs, $pair);

    unless(defined $ENV{REQUEST_METHOD}){return -1;}

    if($ENV{REQUEST_METHOD} eq 'POST'){
        my($temp);
        read(STDIN, $temp, $ENV{CONTENT_LENGTH});
        @pairs = split(/&/, $temp);
    }elsif($ENV{REQUEST_METHOD} eq 'GET'){
        @pairs = split(/&/, $ENV{QUERY_STRING});
    }

    foreach $pair (@pairs){
        local($name, $value) = split(/=/, $pair);
        &DecodeArguement(\$name); &jcode'convert(*name, $JCODE_INT);
        &DecodeArguement(\$value); &jcode'convert(*value, $JCODE_INT);
        $$paaForm{$name} = $value; # /* inner code is EUC. */
    }
    return 0;
}

1;


