#!/usr/local/bin/perl -w

#  MR-Vote 0.01, Copyright (C) 2001 Yamamoto Takanori
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

use FileHandle;
require 'jcode.pl';

require 'common.pl';
require 'csvfunc.pl';


&main();


sub main(){
    my(%aaForm, @aTable);
    &GetArgument(\%aaForm);
    &ReadCSV($TABLEFILE, \@aTable);

    my(@aNewItem);
    &SortCSVItem(\@{$aTable[0]}, \%aaForm, \@aNewItem);
    push(@aNewItem, $ENV{'REMOTE_ADDR'});
    push(@aNewItem, time());

    &AppendCSV($CSVFILE, \@aNewItem);
    &PrintResult(\@{$aTable[0]}, \@aNewItem);
}


sub PrintResult(){
    my($paTable) = shift;
    my($paItem) = shift;

    print "Content-type:text/html\n\n";

    my($fp) = new FileHandle;
    local($format);
    open($fp, $PHASE2HTML);
    while(<$fp>){$format .= $_;}
    close($fp);
    &jcode'convert(*format, $JCODE_INT);

    my($table) = '<TABLE BORDER="1" BGCOLOR='.$TABLECOLOR3.'>';

    my($i)=0;
    while(1){
	unless(defined $$paTable[$i]){last;}
	$table .= "<TR><TD BGCOLOR=$TABLECOLOR2><B>$$paTable[$i]</B></TD><TD BGCOLOR=$TABLECOLOR1><I>";
	if(defined $$paItem[$i]){
            my($tmp) = $$paItem[$i];
            $tmp =~ s/</&lt;/g;
            $tmp =~ s/>/&gt;/g;
	    $table .= $tmp;
	}else{
	    $table .= "<FONT SIZE=\"-1\" COLOR=$BLANKITEMCOLOR>$BLANKITEM</FONT>";
	}
	$table .= "</I></TD></TR>";
	$i++;
    }
    $table .= "</TABLE>\n";

    local($output) = sprintf($format, $table);
    &jcode'convert(*output, $JCODE_EXT);
    print $output;
}


sub SortCSVItem(){
    my($paTable) = shift;
    my($paaForm) = shift;
    my($paReturn) = shift;

    my($k);
    foreach $k (@$paTable){
        my($tmp) = $$paaForm{$k};
	push(@$paReturn, $tmp);
    }
}


