#!/usr/local/bin/perl -w

#  MR-Vote 0.01, Copyright (C) 2001 Yamamoto Takanori
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

use FileHandle;
require 'jcode.pl';

require 'common.pl';
require 'csvfunc.pl';


main();


sub main(){
    my(%aaForm);
    &GetArgument(\%aaForm);
    if($aaForm{'password'} eq $PASSWORD){
	my(@aTable, @aData);
	&ReadCSV($TABLEFILE, \@aTable);
	&ReadCSV($CSVFILE, \@aData);
	&PrintResult(\@{$aTable[0]}, \@aData);
    }else{
	&PrintAuthPrompt();
    }
}


sub PrintAuthPrompt(){
    print "Content-type:text/html\n\n";
    print "<HTML><HEAD><TITLE>***PASSWORD REQUIRED***</TITLE></HEAD><BODY><FORM ACTION=\"$PHASE3CGI\" METHOD=\"POST\">PASSWORD:<INPUT NAME=\"password\" TYPE=\"password\" size=12></FORM></BODY></HTML>";
}


sub PrintResult(){
    my($paTable) = shift;
    my($paData) = shift;

    print "Content-type:text/html\n\n";

    my($fp) = new FileHandle;
    my($format);
    open($fp, $PHASE3HTML);
    while(<$fp>){$format .= $_;}
    &jcode'convert(*format, $JCODE_INT);

    my($table) = '<TABLE BORDER="1" BGCOLOR='.$TABLECOLOR3.'>';

    $table .= "<TR><TD BGCOLOR=$TABLECOLOR2 NOWRAP><B>index</B></TD>";
    my($i)=0;
    foreach (@$paTable){
	$table .= "<TD BGCOLOR=$TABLECOLOR2 NOWRAP><B>$$paTable[$i]</B></TD>";
	$i++;
    }
    $table .= "<TD BGCOLOR=$TABLECOLOR2 NOWRAP><B>REMOTE_ADDR</B></TD>"; #REMOTE_ADDR
    $table .= "<TD BGCOLOR=$TABLECOLOR2 NOWRAP><B>TIMESTAMP</B></TD>";   #TIMESTAMP
    $table .= "</TR>";

    my($j)=0;
    for($j=$#$paData; $j>=0;$j--){
	$table .= "<TR><TD BGCOLOR=$TABLECOLOR2 NOWRAP><B>".($j+1)."</B></TD>";
	my($k);
	for($k=0;$k<$i;$k++){
            $table .= "<TD BGCOLOR=$TABLECOLOR1 NOWRAP><I>";
            if(defined ${$$paData[$j]}[$k]){
                my($tmp) = ${$$paData[$j]}[$k];
                $tmp =~ s/</&lt;/g;
                $tmp =~ s/>/&gt;/g;
	        $table .= $tmp;
            }else{
	        $table .= "<FONT SIZE=\"-1\" COLOR=$BLANKITEMCOLOR>$BLANKITEM</FONT>";
            }
            $table .= "</I></TD>";
	}
        $table .= "<TD BGCOLOR=$TABLECOLOR2 NOWRAP><B>${$$paData[$j]}[$i]</B></TD>";   #REMOTE_ADDR
        $table .= "<TD BGCOLOR=$TABLECOLOR2 NOWRAP><B>".&strLocalTime(${$$paData[$j]}[$i+1])."</B></TD>"; #TIMESTAMP
	$table .= "</TR>";
    }

    $table .= '</TABLE>';

    local($output) = sprintf($format, $table);
    &jcode'convert(*output, $JCODE_EXT);

    print $output;
}


sub strLocalTime(){
    my($t) = shift;
    my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($t);
    return sprintf("%04d/%02d/%02d %02d:%02d:%02d", $year+1900, $mon+1, $mday, $hour, $min, $sec);
}
